;----------------------------------------------------------------------	;
;									;
;	GBA library version 1.0						;
;	for TI-82 (every shells)					;
;	programmed by Martin Bousquet (martin.bousquet@hotmail.fr)	;
;	April 2006							;
;									;
;	You may edit this software only for personnal use,		;
;	don't distribute modified version. If you copy some part of the	;
;	source code, please give me credits.				;
;									;
;----------------------------------------------------------------------	;

;v1.0


START_ADDR		=$9104
GRAPH_MEM		=$88b8
APD_BUF			=$8228
GBA_VAR			=$8bdf	; TEXT_MEM2

;;; variables

screen_width		=GBA_VAR		;1 octet  (12)
screen_height		=GBA_VAR+1		;1 octet  (8)
zero_point		=GBA_VAR+2		;2 octets

new_sprite		=GBA_VAR+4		;2 octets
tile_zero		=GBA_VAR+6		;1 octet
n_tiles2		=GBA_VAR+7		;1 octet

n_sprite		=GBA_VAR+8		;1 octet
sprite_table		=GBA_VAR+9		;2 octets
sprite_max		=GBA_VAR+11		;1 octet
l_sprite		=GBA_VAR+12		;2 octets

tiles_addr		=GBA_VAR+14		;2 octets
map_addr		=GBA_VAR+16		;2 octets
map_width		=GBA_VAR+18		;2 octets
map_height		=GBA_VAR+20		;2 octets
scroll_y		=GBA_VAR+22		;2 octets
scroll_x		=GBA_VAR+24		;2 octets

mask_y			=GBA_VAR+26		;1 octet
mask_x			=GBA_VAR+27		;1 octet
mask_x2			=GBA_VAR+28		;1 octet
temp			=GBA_VAR+29		;1 octet
temp2			=GBA_VAR+30		;1 octet
temp3			=GBA_VAR+31		;1 octet


;;; routines

gba_initmap		=GBA_VAR+32
gba_hl_plus_dexbc	=GBA_VAR+35
gba_restoremap		=GBA_VAR+38
gba_scroll_right	=GBA_VAR+41
gba_scroll_left		=GBA_VAR+44
gba_scroll_up		=GBA_VAR+47
gba_scroll_down		=GBA_VAR+50
gba_collision		=GBA_VAR+53
gba_findsprite		=GBA_VAR+56
gba_initsprite		=GBA_VAR+59
gba_drawsprite		=GBA_VAR+62

gba_scroll_horizontal	=GBA_VAR+65
gba_colonne_1xa		=GBA_VAR+68
gba_scroll_vertical	=GBA_VAR+71
gba_find_tile		=GBA_VAR+74
gba_fin_sprite		=GBA_VAR+77
gba_drawinverted	=GBA_VAR+80

gba_inverted		=GBA_VAR+84

	; GBA_VAR+85


.org START_ADDR
.db "Game Boy Advance",0

	ret

Origine:
.dw initmap-Origine
.dw hl_plus_dexbc-Origine
.dw restoremap-Origine
.dw scroll_right-Origine
.dw scroll_left-Origine
.dw scroll_up-Origine
.dw scroll_down-Origine
.dw collision-Origine
.dw findsprite-Origine
.dw initsprite-Origine
.dw drawsprite-Origine

.dw scroll_horizontal-Origine
.dw colonne_1xa-Origine
.dw scroll_vertical-Origine
.dw find_tile-Origine
.dw Fin_sprite-Origine
.dw drawinverted-Origine

.dw repere-Origine



initmap:
	ld bc,0
	ld (temp),bc
	ld hl,(map_addr)
	ld bc,(scroll_x)
	add hl,bc
	ld bc,(map_width)
	ld de,(scroll_y)
	call gba_hl_plus_dexbc
	ld (mask_y),a
	ld (mask_x2),a
	ld a,%10000000
	ld (mask_x),a
	ld de,APD_BUF
	ld b,12
Initcarte_ligne:
	ld c,8
	push de
	push hl
Initcarte_colonne:
	push bc
	push hl
	call gba_find_tile
	ld a,8
Dessinbloc_8xa:
	ld b,(hl)
	inc hl
	ex de,hl
	ld (hl),b
	ld bc,12
	add hl,bc
	ex de,hl
	dec a
	jr nz,Dessinbloc_8xa
	ld a,8
	ld hl,temp
	add a,(hl)
	ld (hl),a
	pop hl
	ld bc,(map_width)
	add hl,bc
	pop bc
	dec c
	jr nz,Initcarte_colonne
	ld hl,temp
	ld (hl),0
	ld a,8
	inc hl
	add a,(hl)
	ld (hl),a
	pop hl
	inc hl
	pop de
	inc de
	djnz Initcarte_ligne
	ret

hl_plus_dexbc:			; entre:	- hl quelconque
	add hl,de		;		- de peut tre negatif
	dec bc			;		- bc positif
	ld a,b			; sortie:	- HL+DExBC -> HL
	or c			; detruit:	af,bc
	jr nz,hl_plus_dexbc
	ret


restoremap:	
	ld hl,GRAPH_MEM
	ld bc,(zero_point)
	add hl,bc
	ex de,hl
	ld hl,APD_BUF
	ld a,(screen_height)
	add a,a
	add a,a
	add a,a
Restore_boucle:
	push af
	push hl
	push de
	ld bc,(screen_width)
	ld b,0
	ldir
	ld bc,12
	pop hl
	add hl,bc
	ex de,hl
	pop hl
	add hl,bc
	pop af
	dec a
	jr nz,Restore_boucle
	ret


;******************************** SCROLL HORIZONTAL ***************************************

scroll_right:
	ld hl,(map_width)
	ld de,(scroll_x)
	or a
	sbc hl,de
	ld a,(screen_width)
	inc a
	ld d,0
	ld e,a
	sbc hl,de
	ret c

	ld a,(sprite_max)
	or a
	jr z,Scrolld_no
	ld hl,(sprite_table)
	inc hl \ inc hl \ inc hl \ inc hl
	ld de,(l_sprite)
Scrolld_sprite:
	dec (hl)
	add hl,de
	dec a
	jr nz,Scrolld_sprite
	ld bc,$5f00
	ld (temp),bc

Scrolld_no:
	ld hl,APD_BUF+11
	ld b,64
SD_boucle:
	sla (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	ld de,24
	add hl,de
	djnz SD_boucle


	ld a,%00000001
	ld (temp3),a
	ld hl,(map_addr)
	ld bc,12
	add hl,bc
	ld de,APD_BUF+11
	call gba_scroll_horizontal
	ld a,(mask_x2)
	inc a
	and %111
	ld (mask_x2),a
	ld a,(mask_x)
	srl a
	ld (mask_x),a
	ret nc
	ld a,%10000000
	ld (mask_x),a
	ld bc,(scroll_x)
	inc bc
	ld (scroll_x),bc
	or a
	ret

scroll_left:
	ld a,(mask_x)
	cp %10000000
	jr nz,SG_verifok
	ld hl,(scroll_x)
	ld de,1
	sbc hl,de
	ret c
SG_verifok:
	ld a,(sprite_max)
	or a
	jr z,Scrollg_no
	ld hl,(sprite_table)
	inc hl \ inc hl \ inc hl \ inc hl
	ld de,(l_sprite)
Scrollg_sprite:
	inc (hl)
	add hl,de
	dec a
	jr nz,Scrollg_sprite
	
Scrollg_no:
	ld a,(mask_x)
	ld b,-2
temp_boucle:
	inc b
	add a,a
	jr nc,temp_boucle
	ld a,b
	and %111
	neg
	ld b,a
	ld c,0
	ld (temp),bc

	ld hl,APD_BUF
	ld b,64
SG_boucle:
	srl (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	rr (hl)
	inc hl
	djnz SG_boucle
	ld a,(mask_x2)
	dec a
	and %111
	ld (mask_x2),a
	ld a,(mask_x)
	add a,a
	jr nc,SG_suite
	ld a,%00000001
	ld bc,(scroll_x)
	dec bc
	ld (scroll_x),bc
SG_suite:
	ld (mask_x),a
	ld a,%10000000
	ld (temp3),a
	ld hl,(map_addr)
	ld de,APD_BUF
	call gba_scroll_horizontal
	or a
	ret


scroll_horizontal:
	push de
	ld bc,(scroll_x)
	add hl,bc
	ld bc,(map_width)
	ld de,(scroll_y)
	call gba_hl_plus_dexbc
	pop de
	ld a,(mask_y)
	sub 8
	neg

	call gba_colonne_1xa
	ld b,7
SH_boucle2:
	push bc
	ld a,8
	call gba_colonne_1xa
	pop bc
	djnz SH_boucle2
	ld a,(mask_y)
	or a
	ret z
colonne_1xa:
	push hl
	call gba_find_tile
	ld b,a
	ld a,(temp)
	or a
	ld a,b
	jr nz,Colonne_boucle
	ld bc,(mask_y)
	ld b,0
	add hl,bc
Colonne_boucle:
	push af
	ld a,(mask_x)
	and (hl)
	jr z,Colonne_suite
	ex de,hl
	ld a,(temp3)
	or (hl)
	ld (hl),a
	ex de,hl
Colonne_suite:
	inc hl
	ex de,hl
	ld bc,(temp)
	inc c
	ld (temp),bc
	ld bc,12
	add hl,bc
	ex de,hl
	pop af
	dec a
	jr nz,Colonne_boucle
	pop hl
	ld bc,(map_width)
	add hl,bc
	ret




;********************************* SCROLL VERTICAL ***************************************

scroll_up:
	ld a,(mask_y)
	or a
	jr nz,SH_verifok
	ld hl,(scroll_y)
	ld de,1
	sbc hl,de
	ret c
SH_verifok:
	ld a,(sprite_max)
	or a
	jr z,Scrollh_no
	ld hl,(sprite_table)
	inc hl \ inc hl \ inc hl
	ld de,(l_sprite)
Scrollh_sprite:
	inc (hl)
	add hl,de
	dec a
	jr nz,Scrollh_sprite

Scrollh_no:
	ld a,(mask_y)
	dec a
	and %111
	neg
	ld c,a
	ld b,0
	ld (temp),bc

	ld bc,768
	ld hl,APD_BUF+755
	ld de,APD_BUF+767
	lddr

	ld a,(mask_y)
	dec a
	and %111
	ld (mask_y),a
	cp 7
	jr nz,SH_suite
	ld bc,(scroll_y)
	dec bc
	ld (scroll_y),bc
SH_suite:
	ld a,(APD_BUF+12)
	ld (temp3),a
	ld hl,(map_addr)
	ld de,(scroll_x)
	add hl,de
	ld bc,(map_width)
	ld de,(scroll_y)
	call gba_hl_plus_dexbc
	ld de,APD_BUF
	call gba_scroll_vertical
	ld a,(temp3)
	ld (hl),a
	or a
	ret


scroll_down:
	ld hl,(map_height)
	ld de,(scroll_y)
	or a
	sbc hl,de
	ld a,(screen_height)
	inc a
	ld d,0
	ld e,a
	or a
	sbc hl,de
	ret c

	ld a,(sprite_max)
	or a
	jr z,Scrollb_no
	ld hl,(sprite_table)
	inc hl \ inc hl \ inc hl
	ld de,(l_sprite)
Scrollb_sprite:
	dec (hl)
	add hl,de
	dec a
	jr nz,Scrollb_sprite

Scrollb_no:
	ld a,(mask_x2)
	neg
	ld (temp2),a
	ld a,63
	ld (temp),a

	ld bc,768
	ld hl,APD_BUF+12
	ld de,APD_BUF
	ldir

	ld a,(de)
	ld (temp3),a
	ld bc,64					; b=0 c=64
	call gba_collision
	ld de,APD_BUF+756
	call gba_scroll_vertical
	ld a,(temp3)
	ld (hl),a
	ld a,(mask_y)
	inc a
	and %111
	ld (mask_y),a
	ret nz
	ld hl,(scroll_y)
	inc hl
	ld (scroll_y),hl
	or a
	ret


scroll_vertical:
	ld b,13
SV_boucle:
	push bc
	push hl
	call gba_find_tile
	ld bc,(mask_y)
	ld b,0
	add hl,bc
	ld a,(hl)
	ld (de),a
	inc de

	ld bc,8
	ld hl,(temp2)
	add hl,bc
	ld (temp2),hl

	pop hl
	inc hl
	pop bc
	djnz SV_boucle
	dec de
	ex de,hl
	ld a,(mask_x2)
	or a
	ret z
SV_boucle2:
	push hl
	sla (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	dec hl
	rl (hl)
	pop hl
	dec a
	jr nz,SV_boucle2
	ret

collision:			; entre:	- bc: coords x et y, positives
	ld hl,(map_addr)	;		  ou ngatives, d'un point de 
	ld de,(scroll_x)	;		  l'cran (0,0) en haut  gauche
	add hl,de		; sortie:	- hl pointe sur le bloc qui contient
	ld a,(mask_x2)		;		  le point
	add a,b			;		- a=(hl) numro de ce bloc
	sra a \ sra a \ sra a	; dtruit: 	- af,bc,de,hl
	ld e,a
	ld d,0
	bit 7,a
	jr z,Collision_suite
	dec d
Collision_suite:
	add hl,de
	ld de,(scroll_y)
	ld a,(mask_y)
	add a,c
	sra a \ sra a \ sra a
	ld b,0
	ld c,a
	bit 7,a
	jr z,Collision_suite2
	dec b
Collision_suite2:
	ex de,hl
	add hl,bc
	ex de,hl
	ld bc,(map_width)
	call gba_hl_plus_dexbc
	ld a,(hl)
	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; GESTION DES SPRITES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


find_tile:
	ld b,a
	ld a,(n_sprite)
	dec a
	cp (hl)
	jr c,Nouveau_sprite

	ld a,(n_tiles2)
	dec a
	cp (hl)
	jr nc,Bloc_normal
Bloc_type2:
	ld a,(tile_zero)
	ld h,0
	ld l,a
	ld a,b
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,(tiles_addr)
	add hl,bc
	ret
Bloc_normal:
	ld a,b
	ld l,(hl)
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,(tiles_addr)
	add hl,bc
	ret

Nouveau_sprite:
	push de
	push bc
	ld bc,gba_fin_sprite
	push bc
	ld a,(hl)
	and %1
	ret nz

	inc (hl)
	push hl
	call gba_findsprite
	pop de
	ret nz
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ex de,hl
	ld a,(n_sprite)
	inc a
	sub (hl)
	neg
	ld c,a
	ex de,hl
	ld (hl),a
	inc hl
	ld a,(temp)
	ld (hl),a
	ld a,(temp2)
	inc hl
	ld (hl),a
	inc hl
	ex de,hl
	ld hl,(new_sprite)
	ld a,h
	or l
	ret z
	ld a,c
	jp (hl)
	

Fin_sprite:
	pop bc
	pop de
	jr Bloc_type2


findsprite:			; entre:	aucune
	ld hl,(sprite_table)	; sortie:	- hl pointe sur un endroit vide
	ld de,(l_sprite)	;		  de la liste (sprite_table) pour
	ld a,(sprite_max)	;		  crer un nouveau sprite
	ld b,a			;		- s'il n'y a plus de place sur cette
CHCHSPR_boucle:			;		  liste, le zero flag vaudra 1.
	push hl			; dtruit:	- af,de,hl
	ld a,(hl)
	inc hl
	or (hl)
	inc hl
	pop hl
	ret z
	add hl,de
	djnz CHCHSPR_boucle
	or a
	ret

initsprite:				; rinitialise la carte et la liste
	ld hl,0				; des sprites
	ld de,(map_width)
	ld bc,(map_height)
	call gba_hl_plus_dexbc
	ex de,hl
	ld hl,(map_addr)
IS_boucle:
	ld a,(n_sprite)
	cp (hl)
	jr nc,ISboucle_suite
	ld a,%11111110
	and (hl)
	ld (hl),a
ISboucle_suite:
	inc hl
	dec de
	ld a,d
	or e
	jr nz,IS_boucle

	ld hl,(sprite_table)
	ld de,(l_sprite)
	dec de
	ld a,(sprite_max)
IS_boucle2:
	ld (hl),0
	inc hl
	ld (hl),0
	add hl,de
	dec a
	jr nz,IS_boucle2
	ret

drawinverted:
	push hl
	push de
	ld hl,gba_inverted
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld (hl),$2f	; cpl
	inc hl
	ld (hl),$a8	; xor b
	pop de
	pop hl
	call gba_drawsprite
	ld hl,gba_inverted
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld (hl),0
	inc hl
	ld (hl),0
	ret
	

drawsprite:
	bit 7,b
	ret nz
	ld a,(screen_width)
	sub d
	add a,a
	add a,a
	add a,a
	sub b
	ret c

	bit 7,c
	jr z,Cliphaut_ok
Cliphaut_boucle:
	dec e
	ret z
	ld a,d
	add a,a
CH_boucle2:
	inc hl
	dec a
	jr nz,CH_boucle2
	inc c
	jr nz,Cliphaut_boucle
Cliphaut_ok:
	ld a,(screen_height)
	add a,a
	add a,a
	add a,a
	sub c
	ret c
	ret z
	cp e
	jr nc,Clip_ok
	ld e,a
Clip_ok:
	push de
	push hl
	ld hl,GRAPH_MEM-12
	ld de,(zero_point)
	add hl,de
	inc c
	ld de,12
Trouver_ligne:
	add hl,de
	dec c
	jr nz,Trouver_ligne
	ld a,b
Trouver_colonne:
	sub 8
	jr c,Findpixel_fin
	inc hl
	jr Trouver_colonne
Findpixel_fin:
	add a,8
	ld (temp3),a
	pop de
	pop bc
PSM_colonne:
	push bc
	push hl
PSM_ligne:
	push bc
	ld a,(de)
	ld b,a
	ld c,%11111111
	inc de
	push de
	ld a,(de)
repere:
	nop			; utilis pour la routine gba_drawinverted
	nop
	ld d,a
	ld e,0
	ld a,(temp3)
	or a
	jr z,PSM_fin
PSM_Rotation:
	scf
	rr b
	rr c
	srl d
	rr e
	dec a
	or a
	jr nz,PSM_Rotation
PSM_fin:
	ld a,(hl)
	and b
	or d
	ld (hl),a
	inc hl
	ld a,(hl)
	and c
	or e
	ld (hl),a
	pop de
	inc de
	pop bc
	djnz PSM_ligne
	pop hl
	ld bc,12
	add hl,bc
	pop bc
	dec c
	jr nz,PSM_colonne
	ret

.end


